#define UI1 0x33		/* First byte of unique identifier */
#define UI2 0xCC		/* Second byte of unique identifier */


#define HEADER_SIZE 4           /* 4 bytes header */
#define TX_BUFFER_SIZE 64       /* Size (in bytes) of transmit buffer */
#define RX_BUFFER_SIZE 64       /* Size (in bytes) of receive ring-buffer */

#define PREAMBLE_LENGTH 4       /* Number of bytes of preamble to send */

#define PREAMBLE_REQ 4          /* Number of bits required in addition to */
                                /* the initial 8 bits for the preamble to be */
                                /* accepted */
                                
#define FALSE 0
#define TRUE (!FALSE)

/* This struct stores various flags in a space-efficient manner */
extern volatile struct
  {
    unsigned char PreambleFound:1;
    unsigned char UI1Found:1;
    unsigned char LastPreambleBit:1;
    unsigned char LockAverage:1;
    unsigned char UnlockAverage:1;
  };


extern enum StateType {IDLE_STATE,RX_STATE,TX_STATE} State;
extern volatile enum StateType NextState;
extern volatile __bank1 char TXBuffer[TX_BUFFER_SIZE]; 
extern volatile __bank2 char RXBuffer[RX_BUFFER_SIZE];
extern union {
  char ShiftReg;
  struct {
    unsigned char ShiftRegLSB :1;
    unsigned char :1;
    unsigned char :1;
    unsigned char :1;
    unsigned char :1;
    unsigned char :1;
    unsigned char :1;
    unsigned char ShiftRegMSB :1;
  };
};
    
extern char BitCounter;

extern volatile char TXBufferIndex;            
extern char RXBufferReadIndex;
extern volatile char RXBufferWriteIndex;

extern char BytesToSend;
extern char BytesToReceive;

extern char PreambleCount;
extern char PreambleError;

extern char ByteCounter;
